project:
  packs:
    - pack: NXP::LPC55S28_DFP
    - pack: NXP::FREERTOS-KERNEL
    - pack: NXP::USB
    - pack: NXP::Component_OS_Abstraction_Layer
    - pack: ARM::CMSIS@5.9.0
  setups:
    - setup: Options for devcompositecdcvcomcdcvcomfreertos_debug
      for-context: +devcompositecdcvcomcdcvcomfreertos_debug
      processor:
        fpu: sp
        trustzone: non-secure
      add-path:
        - ..
        - ../../../..
      debug: "on"
      define:
        - DEBUG
        - _DEBUG: "1"
        - CPU_LPC55S28JBD100: "1"
        - USB_STACK_FREERTOS
        - USB_STACK_FREERTOS_HEAP_SIZE: "16384"
        - USB_STACK_USE_DEDICATED_RAM: "1"
        - FSL_OSA_BM_TASK_ENABLE: "0"
        - FSL_OSA_BM_TIMER_CONFIG: "0"
        - SDK_DEBUGCONSOLE: "1"
        - MCUXPRESSO_SDK
        - CPU_LPC55S69JBD100_cm33_core0
        - KEIL
        - __MICROLIB
      misc:
        - C:
            - -std=c99
          C-CPP:
            - -mno-unaligned-access  -fno-common  -fdata-sections  -ffreestanding  -fno-builtin  -mthumb
            - -fno-rtti
            - -funsigned-char
            - -fshort-enums
            - -fshort-wchar
            - -ffunction-sections
            - -Wno-packed
            - -Wno-missing-variable-declarations
            - -Wno-missing-prototypes
            - -Wno-missing-noreturn
            - -Wno-sign-conversion
            - -Wno-nonportable-include-path
            - -Wno-reserved-id-macro
            - -Wno-unused-macros
            - -Wno-documentation-unknown-command
            - -Wno-documentation
            - -Wno-license-management
            - -Wno-parentheses-equality
          CPP:
            - -xc++
            - -std=c++11
          Link:
            - --library_type=microlib
            - --map
            - --load_addr_map_info
            - --xref
            - --callgraph
            - --symbols
            - --info sizes
            - --info totals
            - --info unused
            - --info veneers
            - --remove --entry=Reset_Handler --diag_suppress=6314 --predefine="-D__stack_size__=0x2000" --predefine="-D__heap_size__=0x100" --predefine="-D__usb_use_usbram__=1"
            - --strict
            - --diag_suppress=6314
            - --summary_stderr
            - --info summarysizes
    - setup: Options for devcompositecdcvcomcdcvcomfreertos_release
      for-context: +devcompositecdcvcomcdcvcomfreertos_release
      processor:
        fpu: sp
        trustzone: non-secure
      add-path:
        - ..
        - ../../../..
      debug: "off"
      define:
        - NDEBUG
        - _DEBUG: "0"
        - CPU_LPC55S28JBD100: "1"
        - USB_STACK_FREERTOS
        - USB_STACK_FREERTOS_HEAP_SIZE: "16384"
        - USB_STACK_USE_DEDICATED_RAM: "1"
        - FSL_OSA_BM_TASK_ENABLE: "0"
        - FSL_OSA_BM_TIMER_CONFIG: "0"
        - SDK_DEBUGCONSOLE: "1"
        - MCUXPRESSO_SDK
        - CPU_LPC55S69JBD100_cm33_core0
        - KEIL
        - __MICROLIB
      misc:
        - C:
            - -std=c99
          C-CPP:
            - -mno-unaligned-access  -fno-common  -fdata-sections  -ffreestanding  -fno-builtin  -mthumb
            - -fno-rtti
            - -funsigned-char
            - -fshort-enums
            - -fshort-wchar
            - -ffunction-sections
            - -Wno-packed
            - -Wno-missing-variable-declarations
            - -Wno-missing-prototypes
            - -Wno-missing-noreturn
            - -Wno-sign-conversion
            - -Wno-nonportable-include-path
            - -Wno-reserved-id-macro
            - -Wno-unused-macros
            - -Wno-documentation-unknown-command
            - -Wno-documentation
            - -Wno-license-management
            - -Wno-parentheses-equality
          CPP:
            - -xc++
            - -std=c++11
          Link:
            - --library_type=microlib
            - --map
            - --load_addr_map_info
            - --xref
            - --callgraph
            - --symbols
            - --info sizes
            - --info totals
            - --info unused
            - --info veneers
            - --remove --entry=Reset_Handler --diag_suppress=6314 --predefine="-D__stack_size__=0x2000" --predefine="-D__heap_size__=0x100" --predefine="-D__usb_use_usbram__=1"
            - --strict
            - --diag_suppress=6314
            - --summary_stderr
            - --info summarysizes
  linker:
    - script: LPC55S28_flash.scf
  groups:
    - group: board
      files:
        - file: ../pin_mux.c
        - file: ../pin_mux.h
        - file: ../board.c
        - file: ../board.h
        - file: ../clock_config.c
        - file: ../clock_config.h
    - group: source
      files:
        - file: ../composite.c
        - file: ../composite.h
        - file: ../usb_device_descriptor.c
        - file: ../usb_device_descriptor.h
        - file: ../virtual_com.c
        - file: ../virtual_com.h
    - group: doc
      files:
        - file: ../readme.txt
    - group: usb/device/class/cdc
      files:
        - file: ../usb_device_cdc_acm.c
        - file: ../usb_device_cdc_acm.h
    - group: usb/device/source
      files:
        - file: ../usb_device_ch9.c
        - file: ../usb_device_ch9.h
    - group: usb/device/class
      files:
        - file: ../usb_device_class.c
        - file: ../usb_device_class.h
  components:
    - component: NXP::RTOS&FreeRTOS NXP:cm33_non_trustzone_port
    - component: NXP::USB:USB Device:ip3511fs
    - component: NXP::RTOS&FreeRTOS NXP:Core
    - component: NXP::RTOS&FreeRTOS NXP:Heap&Heap_4
    - component: NXP::Device:SDK Drivers:lists
    - component: NXP::Device:SDK Utilities:serial_manager_uart
    - component: NXP::Device:SDK Utilities:serial_manager
    - component: NXP::Device:SDK Drivers:usart
    - component: NXP::Device:SDK Drivers:usart_adapter
    - component: NXP::Device:CMSIS:LPC55S28_header
    - component: NXP::Device:Startup
    - component: NXP::Device:SDK Drivers:clock
    - component: NXP::Device:SDK Drivers:common
    - component: NXP::Device:SDK Drivers:flexcomm
    - component: NXP::Device:SDK Drivers:gpio
    - component: NXP::Device:SDK Drivers:iocon
    - component: NXP::Device:SDK Drivers:power
    - component: NXP::Device:SDK Drivers:reset
    - component: NXP::USB:USB Device:driver
    - component: NXP::USB:USB Device:ip3511hs
    - component: NXP::USB:USB PHY:phy
    - component: NXP::Device:SDK Utilities:assert
    - component: NXP::Device:SDK Utilities:debug_console
    - component: NXP::Device:SDK Utilities:misc_utilities
    - component: NXP::USB:USB Device:ip3511fs_config_header
    - component: NXP::USB:USB Device:common_header
    - component: NXP::NXP Component:OS Abstraction Layer:osa
    - component: NXP::USB:USB Common Header:common_header
    - component: NXP::RTOS&FreeRTOS NXP:freertos template
    - component: NXP::RTOS&FreeRTOS NXP:TAD extension
    - component: ARM::CMSIS:CORE
    - component: NXP::Device:CMSIS:LPC55S28_system
    - component: NXP::USB:USB Device:ip3511hs_config_header
